/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUShaderStage.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "GPUShaderStage.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotCallable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/ObjectPrototype.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>

namespace WebCore {
using namespace JSC;

using JSGPUShaderStageDOMConstructor = JSDOMConstructorNotCallable<JSGPUShaderStage>;

/* Hash table for constructor */

static const std::array<HashTableValue, 3> JSGPUShaderStageConstructorTableValues {
    HashTableValue { "VERTEX"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x1 } },
    HashTableValue { "FRAGMENT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x2 } },
    HashTableValue { "COMPUTE"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x4 } },
};

static_assert(GPUShaderStage::VERTEX == 0x1, "VERTEX in GPUShaderStage does not match value from IDL");
static_assert(GPUShaderStage::FRAGMENT == 0x2, "FRAGMENT in GPUShaderStage does not match value from IDL");
static_assert(GPUShaderStage::COMPUTE == 0x4, "COMPUTE in GPUShaderStage does not match value from IDL");

template<> const ClassInfo JSGPUShaderStageDOMConstructor::s_info = { "GPUShaderStage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUShaderStageDOMConstructor) };

template<> JSValue JSGPUShaderStageDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.objectPrototype();
}

template<> void JSGPUShaderStageDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
    reifyStaticProperties(vm, JSGPUShaderStage::info(), JSGPUShaderStageConstructorTableValues, *this);
    UNUSED_PARAM(globalObject);
}

const ClassInfo JSGPUShaderStage::s_info = { "GPUShaderStage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUShaderStage) };

JSGPUShaderStage::JSGPUShaderStage(Structure* structure, JSDOMGlobalObject& globalObject)
    : JSDOMObject(structure, globalObject) { }

static_assert(!std::is_base_of<ActiveDOMObject, GPUShaderStage>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSValue JSGPUShaderStage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUShaderStageDOMConstructor, DOMConstructorID::GPUShaderStage>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUShaderStage::destroy(JSC::JSCell* cell)
{
    JSGPUShaderStage* thisObject = static_cast<JSGPUShaderStage*>(cell);
    thisObject->JSGPUShaderStage::~JSGPUShaderStage();
}

JSC::GCClient::IsoSubspace* JSGPUShaderStage::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSGPUShaderStage, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForGPUShaderStage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForGPUShaderStage = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForGPUShaderStage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForGPUShaderStage = std::forward<decltype(space)>(space); }
    );
}


}
